﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Diagnostics;
using Infragistics.Windows.Editors;
using Infragistics.Controls.Grids;
using Infragistics.Windows;
using System.Windows.Controls.Primitives;

namespace SelectedItemChangedOnComboColumn
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            ManageRecipeStateResults = new List<Data>
            {
                new Data
                {
                    RecipeKey = 1,
                    MandatoryCriteriaList = "some some some some some some some ",
                    RecipeVersion = 1,
                    PreviousRecipeState = true,
                    CurrentRecipeState = "State 1"
                },
                new Data
                {
                    RecipeKey = 1,
                    MandatoryCriteriaList = "some some some some some some some ",
                    RecipeVersion = 2,
                    PreviousRecipeState = true,
                    CurrentRecipeState = "State 1"
                },
                new Data
                {
                    RecipeKey = 1,
                    MandatoryCriteriaList = "some some some some some some some ",
                    RecipeVersion = 3,
                    PreviousRecipeState = true,
                    CurrentRecipeState = "State 1"
                },
                new Data
                {
                    RecipeKey = 2,
                    MandatoryCriteriaList = "some soooooooooooooooooooooooooooooooooooooooooomeeeeeeee1  gdsgfdgfdgf gdgfdgfd dfdgfddg",
                    RecipeVersion = 2,
                    PreviousRecipeState = true,
                    CurrentRecipeState = "State 2"
                },
            };

            DataContext = this;

            Column mandatoryCriteriaColumn = this.ManageRecipeStateGrid.Columns["MandatoryCriteriaList"] as Column;
            this.ManageRecipeStateGrid.GroupBySettings.GroupByColumns.Add(mandatoryCriteriaColumn);
        }

        public List<Data> ManageRecipeStateResults { get; set; }

        private void ManageRecipeStateGrid_CellControlAttached(object sender, CellControlAttachedEventArgs e)
        {
            TextBlock text = GetChildFromType<ContentPresenter>(e.Cell.Control).Content as TextBlock;
            if (text != null)
                text.TextWrapping = TextWrapping.Wrap;
        }

        private T GetChildFromType<T>(DependencyObject parent) where T : DependencyObject
        {
            T result = null;

            for (int i = 0; i < VisualTreeHelper.GetChildrenCount(parent); i++)
            {
                if (VisualTreeHelper.GetChild(parent, i) is T)
                {
                    return VisualTreeHelper.GetChild(parent, i) as T;
                }
                else
                {
                    result = GetChildFromType<T>(VisualTreeHelper.GetChild(parent, i));

                    if (result != null)
                    {
                        break;
                    }
                }
            }
            return result;
        }

        private void XamComboEditor_SelectedItemChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
           // (sender as XamComboEditor).SelectedItemChanged -= XamComboEditor_SelectedItemChanged;

            Data activeRowData = (Utilities.GetAncestorFromType(sender as DependencyObject, typeof(CellControl), false) as CellControl).Cell.Row.Data as Data;

            if (e.OldValue != null && e.NewValue != null)
            {
                Debug.Write("Old: " + (e.OldValue as ComboData).State + " - New: " + (e.NewValue as ComboData).State);

                if ((e.OldValue as ComboData).State.Equals("State 1") && (e.NewValue as ComboData).State.Equals("State 5"))
                {
                  //  MessageBox.Show("State 5 is not valid when State 1 is selected!!!\nActive MandatoryCriteriaList is: " + activeRowData.MandatoryCriteriaList);
                    ContentPopUp.IsOpen = true;
                    txtToolTip.Text = "State 5 is not valid when State 1 is selected!!!\nActive MandatoryCriteriaList is: " + activeRowData.MandatoryCriteriaList;
                    ContentPopUp.Placement = PlacementMode.Center;
                    (sender as XamComboEditor).SelectedItem 
                        = ((sender as XamComboEditor).ItemsSource as IEnumerable<ComboData>).Where(i => i.State.Equals("State 1")).FirstOrDefault();
                }

                if ((e.OldValue as ComboData).State.Equals("State 2")
               && ((e.NewValue as ComboData).State.Equals("State 4") || (e.NewValue as ComboData).State.Equals("State 5")))
                {
                   // MessageBox.Show("State 4 and State 5 is not valid when State 2 is selected!!!\nActive MandatoryCriteriaList is: " + activeRowData.MandatoryCriteriaList);
                    ContentPopUp.IsOpen = true;
                    txtToolTip.Text = "State 4 and State 5 is not valid when State 2 is selected!!!\nActive MandatoryCriteriaList is: " + activeRowData.MandatoryCriteriaList;
                    ContentPopUp.Placement = PlacementMode.Center;
                    (sender as XamComboEditor).SelectedItem
                                 = ((sender as XamComboEditor).ItemsSource as IEnumerable<ComboData>).Where(i => i.State.Equals("State 2")).FirstOrDefault();
                }
            }
          //  (sender as XamComboEditor).SelectedItemChanged += XamComboEditor_SelectedItemChanged;

        }
    }

    public class IsItemValidConverter : IValueConverter
    {
        object lastSetValue = null;
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            lastSetValue = value;
            return value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (lastSetValue.Equals("State 1")
                && (value.Equals("State 5")))
            {                
                MessageBox.Show("State 5 is not valid when State 1 is selected!!!");
                return lastSetValue;
            }
            if (lastSetValue.Equals("State 2")
                && (value.Equals("State 4") || value.Equals("State 5")))
            {
                MessageBox.Show("State 4 and State 5 is not valid when State 2 is selected!!!");
                return lastSetValue;
            }
            return value;
        }
    }


    public class Data
    {
        public int RecipeKey { get; set; }
        public string MandatoryCriteriaList { get; set; }
        public int RecipeVersion { get; set; }
        public bool PreviousRecipeState { get; set; }
        public string CurrentRecipeState { get; set; }
        public bool IsPreserved { get; set; }
    }


    public class OptionList : List<ComboData>
    {
        public OptionList()
        {
            Add(new ComboData { State = "State 1" });
            Add(new ComboData { State = "State 2" });
            Add(new ComboData { State = "State 3" });
            Add(new ComboData { State = "State 4" });
            Add(new ComboData { State = "State 5" });
        }
    }

    public class ComboData
    {
        public string State { get; set; }
    }
}
